// 4-Tap Lanczos-2 filter for picture scaling with nify error distribution.
// Written by Nils Liaaen Corneliusen 2013.
// License: CC0 1.0 Universal (CC0 1.0) Public Domain Dedication license
// Read the 2023 article here: https://www.ignorantus.com/pages/neon_scaler/
// Read the 2018 article here: https://www.ignorantus.com/pages/image_transformation/

#ifndef COEFFSH
#define COEFFSH

#include <stdint.h>

#define COEFFS_PHASES_BITS 6
#define COEFFS_PHASES      (1<<COEFFS_PHASES_BITS)
#define COEFFS_STARTBIT    (16-COEFFS_PHASES_BITS)
#define COEFFS_STOPBIT     (COEFFS_STARTBIT+COEFFS_PHASES_BITS-1)

#define COEFFS_SUM_BITS    6
#define COEFFS_SUM         (1<<COEFFS_SUM_BITS)

#define COEFFS_ROUNDVAL    (1<<(COEFFS_SUM_BITS-1))

void coeffs_get( float fac, uint32_t *co );

#endif
